import router from "../router.mjs";
import url from "url";
import util from "util";
import sql from "../sql.mjs";

router.get("/stats", async (req, res) => {
  const query = await sql.query("select src from items");
  let hosts = {};
  query.forEach(e => {
    const host = url.parse(e.src).hostname;
    hosts[host] ? hosts[host]++ : hosts[host] = 1;
  });
  
  res.reply({
    body: "<pre>" + util.inspect(Object.keys(hosts).sort((a, b) => hosts[b] - hosts[a]).map(k => ({ [k]: hosts[k] })).reduce((a, b) => ({ ...a, ...b }))) + "</pre>"
  });
});
